#include "cnasica.h"
#include "label.h"
#include "data.h"
#include "dataget.h"

/*
typedef struct s_label SLabel;

struct s_label {
	char name[MAX_IDENT];
	int location;
};
*/

SLabel* LabelLoad(SData *data, int *labels) {
	char ident[MAX_IDENT];
	SLabel *tmp1;
	int i=0;

	*labels = 0;
	data->ptr = 0;
	JumpSpace(data);
	while(data->data[data->ptr] != 0) {
		DataGetIdent(data,ident);
		if(data->data[data->ptr] == ':') {
			(*labels)++;
			(data->ptr)++;
		}

		/* Now jump to the first char of the next line */
		JumpToLineBreak(data);
		JumpLineBreak(data);
		JumpSpace(data);
	}

	if((tmp1 = (SLabel*) malloc(sizeof(SLabel)*(*labels))) == NULL) return NULL;

	data->ptr = 0;
	JumpSpace(data);
	while(data->data[data->ptr] != 0) {
		DataGetIdent(data,ident);
		if(data->data[data->ptr] == ':') {
			(data->ptr)++;
			tmp1[i].location = data->ptr;
			strcpy(tmp1[i].name,ident);
			i++;
		}

		/* Now jump to the first char of the next line */
		JumpToLineBreak(data);
		JumpLineBreak(data);
		JumpSpace(data);
	}

	return tmp1;
}

void LabelFree(SLabel *labellist) {
	free(labellist);
}

int LabelFind(SLabel *labellist, int labels, char *name, int *pos) {
	int i;

	for(i=0;i<labels;i++) {
		if(!stricmp(name,labellist[i].name)) {
			*pos = labellist[i].location;
			return 0;
		}
	}
	return -1;
}
