#ifndef __parse_h__
#define __parse_h__

int ParseIntPrimitive(SVariable *variablelist, SData *data, int *result);
int ParseIntLevel3(SVariable *variablelist, SData *data, int *result);
int ParseIntLevel2(SVariable *variablelist, SData *data, int *result);
int ParseIntLevel1(SVariable *variablelist, SData *data, int *result);
int ParseInt(SVariable *variablelist, SData *data, int *result);

int ParseFloat(SVariable *variablelist, SData *data, double *result);
int ParseFloatLevel1(SVariable *variablelist, SData *data, double *result);
int ParseFloatLevel2(SVariable *variablelist, SData *data, double *result);
int ParseFloatLevel3(SVariable *variablelist, SData *data, double *result);
int ParseFloatPrimitive(SVariable *variablelist, SData *data, double *result);

int ParseString(SVariable *variablelist, SData *data, char *result);

int is_dec(char *s);
int is_float_dec(char *s);
int StrToFloat(char *s, double *result);
int StrToInt(char *s, int *result);

#endif