
' Example program for the Cnasica 0.1 intepreter
'
' Written 2001-11-09 by Robert Oestling

	declare answer:string,file:integer,filename:string,line:string,int:integer
	declare x:float,y:float,z:float
	declare i:integer,j:integer

	print "Example program for Cnasica 0.1"
menu:
	print ""
	print "What do you want to do today?"
	print " (1) File demo"
	print " (2) Math demo"
	print " (3) Loop & sub function demo"
	print " (4) Exit"
	print ""

get_answer:
	print ":";
	input answer
	if (string) answer = "1" then goto file_demo
	if (string) answer = "2" then goto math_demo
	if (string) answer = "3" then goto loop_demo
	if (string) answer = "4" then end
	goto get_answer

file_demo:
	print ""
	print "File name: ";
	input filename
	file = 0
	open file,filename,0	' Open file nr 0 for reading (mode 0)
	if (integer) error <> 0 then goto error

	read file,line			' Let's read a line from the file
	print "This is the first line in your file: "+line

	seek file,0,0			' Seek to the first byte
	read file,int			' Read an integer from the file
	print "This is the first integer in your file: "+int

	goto menu

math_demo:
	print ""
	x = 4*(atan(1/2)+atan(1/3))
	print "Let's calculate PI: "+x
	print ""
	print "X = ";
	input x
	print "Y = ";
	input y
	z = sqrt(sqr(x)+sqr(y))
	print "sqrt(x^2 + y^2) = "+z
	goto menu

loop_demo:
	print ""
	print "How many times do you want to run the empty loop? ";
	input j
	i = 0
	repeat
		i = i + 1
	until (integer) i >= j
	gosub say_hello
	goto menu

error:
	print "Error!"
	end

say_hello:
	print "Hello :-)"
	return